SET autocommit=0;

START TRANSACTION;

CREATE TABLE IF NOT EXISTS `version` (
	`db_version` int(11) NOT NULL DEFAULT 1,
	PRIMARY KEY(`db_version`)
);



CREATE TABLE IF NOT EXISTS`queue` (
    `id` int(11) NOT NULL AUTO_INCREMENT,
    `priority` int(11) NOT NULL DEFAULT '10',
	`video_type` varchar(10) DEFAULT NULL,
	`filename` varchar(250) NOT NULL,
	`host` varchar(150) NOT NULL,
	`imdb_id` varchar(15) DEFAULT NULL,
	`season` tinyint(3) DEFAULT NULL,
	`episode` tinyint(3) DEFAULT NULL,
	`title` varchar(225) DEFAULT NULL,
	`fileid` varchar(75) DEFAULT NULL,
	`raw_url` varchar(225) DEFAULT NULL,
	`url` varchar(225) DEFAULT NULL,
	`save_dir` varchar(225) DEFAULT NULL,
	`source_addon` varchar(225) DEFAULT NULL,
	`status` tinyint(4) NOT NULL DEFAULT '1',
	PRIMARY KEY (`id`)
);

CREATE TABLE IF NOT EXISTS`files` (
    `id` int(11) NOT NULL AUTO_INCREMENT,
	`hash` varchar(100) DEFAULT NULL,
	`path` varchar(250) NOT NULL,
	PRIMARY KEY (`id`),
	UNIQUE KEY `hash_id_UNIQUE` (`hash`)
);

CREATE TABLE IF NOT EXISTS `remote_queue` (
    `id` int(11) NOT NULL AUTO_INCREMENT,
    `service` varchar(75) DEFAULT NULL,
    `hash` varchar(75) DEFAULT NULL,
    `complete` tinyint(4) NOT NULL DEFAULT '0',
    PRIMARY KEY (`id`)
);

ALTER TABLE `queue` ADD `host` VARCHAR(150) AFTER `filename`;

COMMIT;

SET autocommit=1;
