CREATE TABLE IF NOT EXISTS "version" (
	"db_version" INTEGER DEFAULT 1 UNIQUE,
	PRIMARY KEY(db_version)
);


CREATE TABLE IF NOT EXISTS "queue" (
	"id" INTEGER PRIMARY KEY AUTOINCREMENT, 
	"priority" INTEGER DEFAULT (10), 
	"video_type" TEXT, 
	"filename" TEXT,
	"host" TEXT,
	"imdb_id" TEXT,
	"season" INTEGER,
	"episode" INTEGER,
	"title" TEXT,
	"fileid" TEXT, 
	"raw_url" TEXT, 
	"url" TEXT, 
	"save_dir" TEXT,
	"source_addon" TEXT,
	"status" INTEGER DEFAULT (1)
);

CREATE TABLE IF NOT EXISTS "remote_queue" (
    "id" INTEGER PRIMARY KEY AUTOINCREMENT,
    "service" TEXT,
    "hash" TEXT,
    "complete" INTEGER DEFAULT (0)
);

CREATE TABLE IF NOT EXISTS "files" (
    "id" INTEGER PRIMARY KEY AUTOINCREMENT,
    "hash" TEXT UNIQUE,
    "path" TEXT
);

ALTER TABLE "queue" ADD column "host" TEXT AFTER "filename";
