import json
import xbmcgui
from dudehere.routines import *
from dudehere.routines import plugin

AUTH_PIN = plugin.get_setting('auth_pin')

NUMBER_THREADS = int(plugin.get_setting('thread_number'))
if plugin.get_setting('enable_custom_work') == "true":
	WORK_DIRECTORY = plugin.get_setting('work_directory')
else:
	WORK_DIRECTORY = vfs.join(DATA_PATH, 'work')

if plugin.get_setting('enable_custom_output') == "true":
	CACHE_DIRECTORY = plugin.get_setting('save_directory')
else:
	CACHE_DIRECTORY = vfs.join(DATA_PATH, 'downloads')

MOVIE_DIRECTORY = vfs.join(CACHE_DIRECTORY, 'Movies')
TVSHOW_DIRECTORY = vfs.join(CACHE_DIRECTORY, 'TV Shows')
TORRENT_DIRECTORY = vfs.join(CACHE_DIRECTORY, 'Torrents')

BLOCK_SIZE = int(float(plugin.get_setting('block_size')) * 1024 * 1024)
FRAME_SIZE = int(plugin.get_setting('frame_size'))
RETRY_ATTEMPTS = int(plugin.get_setting('retry_attempts'))

WINDOW_PREFIX = 'transmogrifier'
WEB_ROOT = vfs.join(ROOT_PATH, 'resources/www/html')
CONTROL_PORT = int(plugin.get_setting('control_port'))
VALID_TOKENS = []

NOTIFICATION = plugin.get_setting('notification')
if NOTIFICATION == 'None':
	NOTIFICATION = False
else:
	NOTIFICATION = NOTIFICATION.replace(" ", "_").lower()

plugin.log("Work Directory: %s" % WORK_DIRECTORY)
plugin.log("Cache Directory: %s" % CACHE_DIRECTORY)
if not vfs.exists(DATA_PATH): vfs.mkdir(DATA_PATH)
if not vfs.exists(CACHE_DIRECTORY): vfs.mkdir(CACHE_DIRECTORY)
if not vfs.exists(WORK_DIRECTORY): vfs.mkdir(WORK_DIRECTORY)
if not vfs.exists(MOVIE_DIRECTORY): vfs.mkdir(MOVIE_DIRECTORY)
if not vfs.exists(TVSHOW_DIRECTORY): vfs.mkdir(TVSHOW_DIRECTORY)
if not vfs.exists(TORRENT_DIRECTORY): vfs.mkdir(TORRENT_DIRECTORY)

def get_property(k):
	p = xbmcgui.Window(10000).getProperty('GenericPlaybackService.' + k)
	if p == 'false': return False
	if p == 'true': return True
	return p
	
def set_property(k, v):
	xbmcgui.Window(10000).setProperty('GenericPlaybackService.' + k, v)

def clear_property(k):
	xbmcgui.Window(10000).clearProperty('GenericPlaybackService.' + k)