import xbmc
from dudehere.routines import *
from dudehere.routines import plugin
if plugin.get_setting('database_type')=='1':
	DB_NAME = plugin.get_setting('database_mysql_name')
	DB_USER = plugin.get_setting('database_mysql_user')
	DB_PASS = plugin.get_setting('database_mysql_pass')
	DB_PORT = plugin.get_setting('database_mysql_port')
	DB_ADDRESS = plugin.get_setting('database_mysql_host')
	DB_TYPE = 'mysql'
	from dudehere.routines.database import MySQLDatabase as DatabaseAPI
else:
	DB_TYPE = 'sqlite'
	DB_FILE = xbmc.translatePath(plugin.get_setting('database_sqlite_file'))
	from dudehere.routines.database import SQLiteDatabase as DatabaseAPI

class MyDatabaseAPI(DatabaseAPI):
	def _initialize(self):

		schema_file = VFSClass().join(ROOT_PATH, 'resources/database/schema.%s.sql' % self.db_type)
		if self.run_script(schema_file, commit=False):
			self.execute('DELETE FROM version WHERE 1')
			self.execute('INSERT INTO version(db_version) VALUES(?)', [self.db_version])
			self.commit()
	
	def do_init(self):
		do_init = True
		try:
			test = self.query("SELECT 1 FROM version WHERE db_version >= ?", [self.db_version], silent=True)
			if test:
				do_init = False
		except:
			do_init = True
		return do_init
DB_VERSION = 5

if DB_TYPE == 'mysql':
	DB=MyDatabaseAPI(DB_ADDRESS, DB_NAME, DB_USER, DB_PASS, DB_PORT, version=DB_VERSION, connect=False, quiet=True,)
else:
	DB = MyDatabaseAPI(DB_FILE, version=DB_VERSION, connect=False, quiet=True,)
